import {
  world,
  system
} from "@minecraft/server";

function dropGear(player, slot, mult) {
    const equipment = player.getComponent('equippable');
    const target = equipment.getEquipment(slot);

    if(!target || !equipment) return;

    const VD = player.getViewDirection();
    const PL = player.location;

    if(slot == "Mainhand" || slot == "Offhand")
    {player.dimension.spawnItem(target, {x: (PL.x + (VD.x*mult)), y: PL.y +4, z: (PL.z + (VD.z*mult))}); }
    else
    { 
      player.dimension.spawnItem(target, {x: (PL.x + (VD.x*mult)), y: PL.y+1, z: (PL.z + (VD.z*mult))});
      const randPitch = (Math.random()/2) + 0.2;
      player.playSound('armor.equip_diamond', {location: PL, pitch: randPitch, volume: 0.7});
    }
    
    equipment.setEquipment(slot, undefined);

}

system.runInterval(() => {
  for (const player of world.getPlayers()) {
    if(player.hasTag('origins:drop_head')) {
      player.removeTag('origins:drop_head')
      dropGear(player, "Head", 1)
    }
    if(player.hasTag('origins:drop_chest')) {
      player.removeTag('origins:drop_chest')
      dropGear(player, "Chest", 1)
    }
    if(player.hasTag('origins:drop_legs')) {
      player.removeTag('origins:drop_legs')
      dropGear(player, "Legs", 1)
    }
    if(player.hasTag('origins:drop_feet')) {
      player.removeTag('origins:drop_feet')
      dropGear(player, "Feet", 1)
    }
    if(player.hasTag('origins:drop_main_hand')) {
      player.removeTag('origins:drop_main_hand')
      dropGear(player, "Mainhand", 4)
    }
    if(player.hasTag('origins:drop_off_hand')) {
      player.removeTag('origins:drop_off_hand')
      dropGear(player, "Offhand", 4)
    }
  }
})
