import {
  world,
  BlockType,
  BlockTypes,
  system,
  PlayerJoinAfterEvent,
  BlockStates,
  EntityHealthComponent
} from "@minecraft/server";

const foodTypeId = [
  'minecraft:apple',
  'minecraft:baked_potato',
  'minecraft:beef',
  'minecraft:beetroot',
  'minecraft:beetroot_soup',
  'minecraft:bread',
  'minecraft:carrot',
  'minecraft:chicken',
  'minecraft:chorus_fruit',
  'minecraft:cod',
  'minecraft:cooked_beef',
  'minecraft:cooked_chicken',
  'minecraft:cooked_cod',
  'minecraft:cooked_mutton',
  'minecraft:cooked_porkchop',
  'minecraft:cooked_rabbit',
  'minecraft:cooked_salmon',
  'minecraft:cookie',
  'minecraft:dried_kelp',
  'minecraft:enchanted_golden_apple',
  'minecraft:glow_berries',
  'minecraft:golden_apple',
  'minecraft:golden_carrot',
  'minecraft:honey_bottle',
  'minecraft:melon_slice',
  'minecraft:mushroom_stew',
  'minecraft:mutton',
  'minecraft:poisonous_potato',
  'minecraft:porkchop',
  'minecraft:potato',
  'minecraft:pufferfish',
  'minecraft:pumpkin_pie',
  'minecraft:rabbit',
  'minecraft:rabbit_stew',
  'minecraft:rotten_flesh',
  'minecraft:salmon',
  'minecraft:spider_eye',
  'minecraft:suspicious_stew',
  'minecraft:sweet_berries',
  'minecraft:tropical_fish'
];

const vegetarianCantEat = [
  'minecraft:beef',
  'minecraft:chicken',
  'minecraft:cod',
  'minecraft:cooked_beef',
  'minecraft:cooked_chicken',
  'minecraft:cooked_cod',
  'minecraft:cooked_mutton',
  'minecraft:cooked_porkchop',
  'minecraft:cooked_rabbit',
  'minecraft:cooked_salmon',
  'minecraft:mutton',
  'minecraft:porkchop',
  'minecraft:pufferfish',
  'minecraft:rabbit',
  'minecraft:rabbit_stew',
  'minecraft:rotten_flesh',
  'minecraft:salmon',
  'minecraft:spider_eye',
  'minecraft:tropical_fish'
];

const carnivoreCantEat = [
  'minecraft:apple',
  'minecraft:baked_potato',
  'minecraft:beetroot',
  'minecraft:beetroot_soup',
  'minecraft:bread',
  'minecraft:carrot',
  'minecraft:chorus_fruit',
  'minecraft:cookie',
  'minecraft:dried_kelp',
  'minecraft:enchanted_golden_apple',
  'minecraft:glow_berries',
  'minecraft:golden_apple',
  'minecraft:golden_carrot',
  'minecraft:honey_bottle',
  'minecraft:melon_slice',
  'minecraft:mushroom_stew',
  'minecraft:poisonous_potato',
  'minecraft:potato',
  'minecraft:pumpkin_pie',
  'minecraft:rabbit_stew',
  'minecraft:suspicious_stew',
  'minecraft:sweet_berries'
];

const cakes = [
  "minecraft:cake",
  "minecraft:black_candle_cake",
  "minecraft:blue_candle_cake",
  "minecraft:brown_candle_cake",
  "minecraft:candle_cake",
  "minecraft:cyan_candle_cake",
  "minecraft:gray_candle_cake",
  "minecraft:green_candle_cake",
  "minecraft:light_blue_candle_cake",
  "minecraft:light_gray_candle_cake",
  "minecraft:lime_candle_cake",
  "minecraft:magenta_candle_cake",
  "minecraft:orange_candle_cake",
  "minecraft:pink_candle_cake",
  "minecraft:purple_candle_cake",
  "minecraft:red_candle_cake",
  "minecraft:white_candle_cake",
  "minecraft:yellow_candle_cake",
]


world.afterEvents.itemCompleteUse.subscribe((event) => {
  const item = event.itemStack;
  const player = event.source;


  if (!item || !player) {
    return;
  }
  if (!foodTypeId.includes(item.typeId)) {
    return;
  }

  var tag = item.typeId.replace('minecraft:', '');

  player.addTag(`origins:ate_${tag}`);
  player.addTag('origins:ate_food');

  if(player.hasTag('origins:alylica_debugger')) {
    player.sendMessage(`added tags to player : origins:ate_${tag} & origins:ate_food`);
  }
  
})

world.beforeEvents.itemUse.subscribe(fr => {

  const food = fr.itemStack;
  const player = fr.source;

  if(!foodTypeId.includes(food.typeId)) return;
  if(player.typeId != "minecraft:player") return;

    
  
// this condition is to bypass all of the condition for a particular food
  if(!player.hasTag("origins:food_allow_"+food.typeId))
  {
    if(player.hasTag("origins:no_food")) fr.cancel = true; 
    if(player.hasTag("origins:vegetarian") && vegetarianCantEat.includes(food.typeId)) fr.cancel = true;
    if(player.hasTag("origins:carnivore") && carnivoreCantEat.includes(food.typeId)) fr.cancel = true;
    if(player.hasTag("origins:food_deny_"+food.typeId)) fr.cancel = true;
  }

  



});

world.beforeEvents.playerInteractWithBlock.subscribe(cr =>{

    const block = cr.block;
    const player = cr.player;
    const item = cr.itemStack;
    if(player.hasTag("origins:food_allow_minecraft:cake")) return;
    if(cakes.includes(block.typeId) && (player.hasTag("origins:carnivore") || player.hasTag("origins:food_deny_minecraft:cake") || player.hasTag("origins:no_food")))
    {
      if(!(item && cakes.includes(item.typeId+"_cake") && block.typeId == "minecraft:cake" && block.permutation.getState("bite_counter")==0))
      {
        cr.cancel = true; 
      }  
    }
});