import {
  world,
  ItemStack
} from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.itemComponentRegistry.registerCustomComponent('origins:orb', {
    onUse(e) {
      const player = e.source;
      const item = e.itemStack;

      if (!player.matches({gameMode: 'creative'})) {
        player.runCommand('clear @s origins:orb_of_origin -1 1');
      }

      player.addTag('origins:reset_origin');
    }
  });


  initEvent.itemComponentRegistry.registerCustomComponent('origins:power_item', {
    onUse(e) {
      const player = e.source;
      const item = e.itemStack;

      player.addTag(`${item.typeId}_use`);
      player.addTag('origins:power_used');
    },
    onHitEntity(e) {
      const attacker = e.attackingEntity;
      const target = e.hitEntity;
      const item = e.itemStack;

      attacker.addTag(`${item.typeId}_hit`);
      attacker.addTag('origins:power_used');

      target.addTag(`${item.typeId}_hit_by`);
      target.addTag('origins:power_hit');
    }
  });
});