import { world, Player, Entity, ItemStack, EquipmentSlot, EntityComponent, system } from "@minecraft/server";

// This script is for testing mobs and should be disable for normal gameplay ,it also assumes the tester is a human origin

const scare =
[
    "origins:mob_allay_scare",
    "origins:mob_armadillo_scare",
    "origins:mob_axolotl_scare",
    "origins:mob_bat_scare",
    "origins:mob_bee_scare",
    "origins:mob_blaze_scare",
    "origins:mob_bogged_scare",
    "origins:mob_breeze_scare",
    "origins:mob_camel_scare",
    "origins:mob_cave_spider_scare",
    "origins:mob_chicken_scare",
    "origins:mob_cow_scare",
    "origins:mob_creaking_scare",
    "origins:mob_creeper_scare",
    "origins:mob_dolphin_scare",
    "origins:mob_donkey_scare",
    "origins:mob_drowned_scare",
    "origins:mob_elder_guardian_scare",
    "origins:mob_enderman_scare",
    "origins:mob_endermite_scare",
    "origins:mob_evocation_illager_scare",
    "origins:mob_fox_scare",
    "origins:mob_frog_scare",
    "origins:mob_ghast_scare",
    "origins:mob_glow_squid_scare",
    "origins:mob_goat_scare",
    "origins:mob_guardian_scare",
    "origins:mob_hoglin_scare",
    "origins:mob_horse_scare",
    "origins:mob_husk_scare",
    "origins:mob_iron_golem_scare",
    "origins:mob_llama_scare",
    "origins:mob_magma_cube_scare",
    "origins:mob_mooshroom_scare",
    "origins:mob_mule_scare",
    "origins:mob_ocelot_scare",
    "origins:mob_panda_scare",
    "origins:mob_parrot_scare",
    "origins:mob_phantom_scare",
    "origins:mob_pig_scare",
    "origins:mob_piglin_brute_scare",
    "origins:mob_piglin_scare",
    "origins:mob_pillager_scare",
    "origins:mob_polar_bear_scare",
    "origins:mob_pufferfish_scare",
    "origins:mob_ravager_scare",
    "origins:mob_sheep_scare",
    "origins:mob_silverfish_scare",
    "origins:mob_skeleton_horse_scare",
    "origins:mob_skeleton_scare",
    "origins:mob_slime_scare",
    "origins:mob_sniffer_scare",
    "origins:mob_snow_golem_scare",
    "origins:mob_spider_scare",
    "origins:mob_squid_scare",
    "origins:mob_stray_scare",
    "origins:mob_strider_scare",
    "origins:mob_tadpole_scare",
    "origins:mob_trader_llama_scare",
    "origins:mob_turtle_scare",
    "origins:mob_vex_scare",
    "origins:mob_villager_scare",
    "origins:mob_vindicator_scare",
    "origins:mob_wandering_villager_scare",
    "origins:mob_warden_scare",
    "origins:mob_witch_scare",
    "origins:mob_wither_skeleton_scare",
    "origins:mob_wither_scare",
    "origins:mob_wolf_scare",
    "origins:mob_zoglin_scare",
    "origins:mob_zombie_horse_scare",
    "origins:mob_zombie_pigman_scare",
    "origins:mob_zombie_villager_scare",
    "origins:mob_zombie_scare",
]

const attack_on_sight =
[
    "origins:mob_allay_attack_on_sight",
    "origins:mob_armadillo_attack_on_sight",
    "origins:mob_axolotl_attack_on_sight",
    "origins:mob_bat_attack_on_sight",
    "origins:mob_bee_attack_on_sight",
    "origins:mob_camel_attack_on_sight",
    "origins:mob_cat_attack_on_sight",
    "origins:mob_chicken_attack_on_sight",
    "origins:mob_cow_attack_on_sight",
    "origins:mob_dolphin_attack_on_sight",
    "origins:mob_donkey_attack_on_sight",
    "origins:mob_enderman_attack_on_sight",
    "origins:mob_cod_attack_on_sight",
    "origins:mob_fox_attack_on_sight",
    "origins:mob_glow_squid_attack_on_sight",
    "origins:mob_horse_attack_on_sight",
    "origins:mob_iron_golem_attack_on_sight",
    "origins:mob_llama_attack_on_sight",
    "origins:mob_mooshroom_attack_on_sight",
    "origins:mob_mule_attack_on_sight",
    "origins:mob_ocelot_attack_on_sight",
    "origins:mob_panda_attack_on_sight",
    "origins:mob_parrot_attack_on_sight",
    "origins:mob_pig_attack_on_sight",
    "origins:mob_piglin_attack_on_sight",
    "origins:mob_polar_bear_attack_on_sight",
    "origins:mob_rabbit_attack_on_sight",
    "origins:mob_salmon_attack_on_sight",
    "origins:mob_sheep_attack_on_sight",
    "origins:mob_skeleton_horse_attack_on_sight",
    "origins:mob_sniffer_attack_on_sight",
    "origins:mob_snow_golem_attack_on_sight",
    "origins:mob_squid_attack_on_sight",
    "origins:mob_strider_attack_on_sight",
    "origins:mob_tadpole_attack_on_sight",
    "origins:mob_trader_llama_attack_on_sight",
    "origins:mob_tropicalfish_attack_on_sight",
    "origins:mob_turtle_attack_on_sight",
    "origins:mob_wolf_attack_on_sight",
    "origins:mob_zombie_horse_attack_on_sight",
    "origins:mob_zombie_pigman_attack_on_sight",
]

const neutral =
[
    "origins:mob_blaze_neutral",
    "origins:mob_bogged_neutral",
    "origins:mob_breeze_neutral",
    "origins:mob_cat_neutral",
    "origins:mob_cave_spider_neutral",
    "origins:mob_creaking_neutral",
    "origins:mob_creeper_neutral",
    "origins:mob_drowned_neutral",
    "origins:mob_elder_guardian_neutral",
    "origins:mob_enderman_neutral",
    "origins:mob_endermite_neutral",
    "origins:mob_evocation_illager_neutral",
    "origins:mob_cod_neutral",
    "origins:mob_fox_neutral",
    "origins:mob_ghast_neutral",
    "origins:mob_goat_neutral",
    "origins:mob_guardian_neutral",
    "origins:mob_hoglin_neutral",
    "origins:mob_husk_neutral",
    "origins:mob_magma_cube_neutral",
    "origins:mob_phantom_neutral",
    "origins:mob_piglin_brute_neutral",
    "origins:mob_piglin_neutral",
    "origins:mob_pillager_neutral",
    "origins:mob_polar_bear_neutral",
    "origins:mob_pufferfish_neutral",
    "origins:mob_rabbit_neutral",
    "origins:mob_ravager_neutral",
    "origins:mob_salmon_neutral",
    "origins:mob_shulker_neutral",
    "origins:mob_silverfish_neutral",
    "origins:mob_skeleton_neutral",
    "origins:mob_slime_neutral",
    "origins:mob_spider_neutral",
    "origins:mob_stray_neutral",
    "origins:mob_tropicalfish_neutral",
    "origins:mob_vex_neutral",
    "origins:mob_vindicator_neutral",
    "origins:mob_warden_neutral",
    "origins:mob_witch_neutral",
    "origins:mob_wither_skeleton_neutral",
    "origins:mob_wither_neutral",
    "origins:mob_zoglin_neutral",
    "origins:mob_zombie_villager_neutral",
    "origins:mob_zombie_neutral",
]

world.afterEvents.itemUse.subscribe(vo => {
    const player = vo.source;
    const item = vo.itemStack;
    if(item.typeId != "minecraft:paper") return;
    let mode = item.nameTag.toLowerCase();

    if(mode == "scare" || mode  == "neutral" || mode == "attack_on_sight")
    {
        let mob_list = [];
       if(mode == "scare") mob_list = scare;
       else if(mode == "neutral") mob_list = neutral;
       else if(mode == "attack_on_sight") mob_list = attack_on_sight;

       for( let tag of mob_list)
       { player.addTag(tag); }

    }
    else if(item.typeId === "minecraft:paper" && mode == "reset")
    {
        for(let tag of player.getTags())
        { 
            if(!((tag.startsWith("origins:selected") && tag.endsWith("origin")) || tag == "origins:selected_origin"))
            {
                player.removeTag(tag);
            }
        }
    }
});