import {
  world,
  ItemStack,
  system
} from "@minecraft/server";

world.afterEvents.itemUse.subscribe(e => {
  const power = e.itemStack;

  if (power.typeId == "origins:power1") {
    const player = e.source;

    if (player.hasTag("origins:energised_aura")) {
      const playerBlock = player.dimension.getBlock(player.location);
      const blockId = playerBlock.typeId;
      const loc = player.location;

      playerBlock.setType('minecraft:redstone_block');
      system.runTimeout(() => {
        playerBlock.setType(blockId);
        
        player.removeTag('origins:energised_aura')
        player.runCommand(`teleport ${loc.x} ${loc.y} ${loc.z}`);
      }, 2)
    }
  }
});

