import { world,ItemStack} from "@minecraft/server";

world.afterEvents.itemUse.subscribe(e =>{
    const power = e.itemStack;

    if(power.typeId == "origins:power1")
    {
        const player = e.source;

        if(player.hasTag("origins:can_pounce"))
        {
            player.runCommand(`clear @s origins:power1`);
            let vd = player.getViewDirection();

            player.applyKnockback(vd.x , vd.z , 4 , 2.2);
            player.addTag("origins:did_pounce");
            player.removeTag("origins:can_pounce");
            world.scoreboard.getObjective("pounce_cd").setScore(player, 60);
            player.runCommand(`title @s actionbar show_pounce_resource_bar`);
            player.addEffect("hunger", 20 , {"amplifier":9 , "showParticles":false});
            player.addEffect("strength",2000000 , {"amplifier":0 , "showParticles":false});
        }
        else if(player.hasTag("origins:can_slime_jump"))
        {
            player.runCommand(`clear @s origins:power1`);
            player.applyKnockback(player.location.x , player.location.z , 0 , 2);
            player.removeTag("origins:can_slime_jump");
            world.scoreboard.getObjective("elastic_cd").setScore(player, 60);
            player.runCommand(`title @s actionbar show_elastic_body_resource_bar`);
        }
        else if(player.hasTag("origins:can_sky_launch"))
        {
            player.runCommand(`clear @s origins:power1`);
            let strength,cooldown,time;
            if(world.scoreboard.getObjective('od:day').getScore(player) == 1)
            { strength = 3.5; cooldown=700;time="day";} //50 blocks at day
            else
            { strength = 4.12; cooldown=840;time="night";} // 65 blocks at night
            player.applyKnockback(player.location.x , player.location.z , 0 , strength);
            player.addTag("origins:did_sky_launch");
            player.removeTag("origins:can_sky_launch");
            world.scoreboard.getObjective("sky_launch_cd").setScore(player, cooldown);
            player.runCommand(`title @s actionbar show_sky_launch_${time}_resource_bar`);

            
        }
        
    }
});