import { world, system } from "@minecraft/server";

/**
 * @param {Entity} entity
 * @param {number} horizontalPower
 * @param {number} verticalPower
 */

function applyVelocityHorizontal(entity, horizontalPower, verticalPower=0) {
  entity.applyKnockback(Math.sin(-entity.getRotation().y*Math.PI/180), Math.cos(-entity.getRotation().y*Math.PI/180), horizontalPower, verticalPower);
}


system.runInterval(() => {
  for (const player of world.getPlayers({tags: ["origins:like_air"]})) {
    if(!player.isFlying && !player.isInWater && !player.isGliding && !player.isOnGround && player.isSprinting && player.getVelocity().y < 0.05) applyVelocityHorizontal(player, 0.5, -0.033);
  }
})