import { world,ItemStack} from "@minecraft/server";

const natural_stones = [
    "minecraft:stone",
    "minecraft:granite",
    "minecraft:diorite",
    "minecraft:andesite",
    "minecraft:sandstone",
    "minecraft:red_sandstone",
    "minecraft:deepslate",
    "minecraft:tuff",
    "minecraft:blackstone",
    "minecraft:basalt",
    "minecraft:smooth_basalt",
    "minecraft:calcite",
    "minecraft:dripstone_block"
]
//calcite and dripstone weren't affected by this but I think they should be

//Strong arms
world.afterEvents.playerBreakBlock.subscribe( sa =>{
    const player = sa.player;
    const block = sa.brokenBlockPermutation;
    const block2 = sa.block;
    //console.warn(sa.itemStackAfterBreak.typeId);
    if(!player.hasTag('origins:strong_arms'))return;
    if(player.getGameMode() == "creative") return;

    //console.warn(sa.itemStackAfterBreak.typeId);
    if(!(sa.itemStackAfterBreak && sa.itemStackAfterBreak.typeId.includes("pickaxe")))
    {
        var item = "";
        if(block.type.id == "minecraft:stone")
        { item = new ItemStack("minecraft:cobblestone",1);  }
        else if(block.type.id == "minecraft:deepslate")
        { item = new ItemStack("minecraft:cobbled_deepslate",1); }
        else
        { item = new ItemStack(block.type.id,1); } 

        player.dimension.spawnItem(item,block2.location);
        
    }

}, {blockTypes : natural_stones} );



//Weak arms
world.beforeEvents.playerBreakBlock.subscribe( wa =>{
    const player = wa.player;
    const block = wa.block;
    if(!player.hasTag('origins:weak_arms'))return;
    if(player.getGameMode() == "creative") return;
    if(player.getEffect("minecraft:strength")) return;
    var stone_count =0;
    stone_count += (natural_stones.includes(block.above(1).typeId))?1:0;
    stone_count += (natural_stones.includes(block.below(1).typeId))?1:0;
    stone_count += (natural_stones.includes(block.north(1).typeId))?1:0;
    stone_count += (natural_stones.includes(block.south(1).typeId))?1:0;
    stone_count += (natural_stones.includes(block.east(1).typeId))?1:0;
    stone_count += (natural_stones.includes(block.west(1).typeId))?1:0;
  
    if(stone_count > 2)
    {  wa.cancel = true;  }

}, {blockTypes : natural_stones} );