import { world, system, ItemStack } from "@minecraft/server";

system.afterEvents.scriptEventReceive.subscribe((event) => {
  const id = event.id;
  const entity = event.sourceEntity;
  const message = event.message;
  if (id === 'origins:decrease_itemstack') {
    const value = parseInt(message);
    if (!value) {
      console.warn('No value specified');
      return;
    }
    const item = entity.getComponent("minecraft:equippable").getEquipment("Mainhand");
    if (!item) {
      console.warn('No held item found');
      return;
    }
    if (item.amount > value) {
      item.amount -= value;
      entity.getComponent("minecraft:equippable").setEquipment('Mainhand', item);
    } else {
      entity.getComponent("minecraft:equippable").setEquipment('Mainhand', undefined);
    }
    return;
  }

  if (id === 'origins:increase_itemstack') {
    const value = parseInt(message);
    if (!value) {
      console.warn('No value specified');
      return;
    }
    const item = entity.getComponent("minecraft:equippable").getEquipment("Mainhand");
    if (!item) {
      console.warn('No held item found');
      return;
    }
    item.amount += value;
    entity.getComponent("minecraft:equippable").setEquipment('Mainhand', item);
    return;
  }

  if (id === 'origins:edit_durability') {
    const value = parseInt(message);
    if (!value) {
      console.warn('No value specified');
      return;
    }
    const item = entity.getComponent("minecraft:equippable").getEquipment("Mainhand");
    if (!item) {
      console.warn('No held item found');
      return;
    }
    const durability = item.getComponent('minecraft:durability');
    if (!durability) {
      console.warn('Held item has no durability');
      return;
    }
    //world.sendMessage(`damage = ${durability.damage}\n after = ${durability.damage - value}\n maxDamage = ${durability.maxDurability}`);
    if(durability.damage - value < 0 && durability.damage - value < durability.maxDurability) {
      durability.damage = 0;
      entity.getComponent("minecraft:equippable").setEquipment('Mainhand', item);
    } else if(durability.damage - value > durability.maxDurability) {
      entity.getComponent("minecraft:equippable").setEquipment('Mainhand', undefined);
    } else {
        durability.damage -= value;
        entity.getComponent("minecraft:equippable").setEquipment('Mainhand', item);
    }
    return;
  }
});